// NOTE : Below is a String I use to add to the data sent to the Nextion Display
//        And to verify the end of the string for incoming data.
//        Replace 3 x Serial2.write(0xff);
String  endChar = String(char(0xff)) + String(char(0xff)) + String(char(0xff));
String  dfd  = ""; // data from display
// NOTE : General Async Delay 
unsigned	long asyncDelay = 0;// NOTE : 4,294,967,295
int	delayLength = 10;
// NOTE : Comment out the next two lines if using an Arduino with more than 1 serial port(MEGA)
#include <SoftwareSerial.h>
SoftwareSerial Serial2(2, 3); // RX, TX

#include <Wire.h>// NOTE : SDA -> A4 : ACL -> A5

void setup() {
  Serial.begin(9600);
  Serial2.begin(9600);
  pinMode(13,OUTPUT);
  Serial.println("STARTING I2C...");
  Wire.begin();
  delay(200);
  Serial.println("Configure the Power Management Register 0x00");
  Wire.beginTransmission(0x68);
  Wire.write(0x6B);
  Wire.write(0x00);
  Wire.endTransmission(true);
  delay(500);
  Serial.println("Configure the GYRO Register 0x10");
  Wire.beginTransmission(0x68);
  Wire.write(0x1B);
  Wire.write(0x10);// NOTE : 1000 deg per second setting
  Wire.endTransmission(true);
  delay(500);
  Serial.println("Configure the ACCEL Register 0x08");
  Wire.beginTransmission(0x68);
  Wire.write(0x1C);
  Wire.write(0x08);// NOTE : 4g setting
  Wire.endTransmission(true);
  delay(500);
}

void loop() {
  // NOTE : COLLECT CHARACTERS FROM NEXTION DISPLAY
  if(Serial2.available()){
    inputFunction();
  }
  // NOTE : ASYNC DELAY
  if(millis() > asyncDelay){
    asyncDelay+=delayLength;
    delayFunction();
  }
}
